<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';
import Badge from '../common/badge.vue';
import SolutionsVideoModal from './video-modal.vue';

export default Vue.extend({
  name: 'SolutionsHero',
  components: {
    SolutionsVideoModal,
    Badge,
  },
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      parallax: this.data.parallax || false,
      showModal: false,
    };
  },
  computed: {
    titleVariant() {
      if (!this.data.title_variant) {
        return 'heading1-bold';
      }

      return this.isMobile && this.data.mobile_title_variant
        ? this.data.mobile_title_variant
        : this.data.title_variant;
    },
  },
  mounted() {
    if (this.parallax) {
      const observer = new IntersectionObserver(this.parallaxSection, {
        rootMargin: '0px',
        threshold: 0,
      });
      const children = Array.from(document.querySelectorAll('.container__row'));
      children.forEach((child) => observer.observe(child));
    }
  },
  methods: {
    parallaxSection(entries: any) {
      const headerHeight = (document as any)
        .querySelector('.nav-hoc')
        .getBoundingClientRect().height;
      entries.forEach((entry: any) => {
        const element = entry.target;
        const text = element.querySelector('.text-column');
        const image = element.querySelector('.image-column');
        if (entry.intersectionRatio > 0) {
          document.addEventListener('scroll', () => {
            const textDistanceFromTop =
              text.getBoundingClientRect().top - headerHeight;
            const imgDistanceToTop =
              image.getBoundingClientRect().top - headerHeight;
            text.style.transform = `translateY(${
              1 - textDistanceFromTop / 100
            }%)`;
            image.style.transform = `translateY(${imgDistanceToTop / 100}%)`;
          });
        }
      });
    },
    openModal() {
      this.showModal = true;
    },
  },
});
</script>
<template>
  <section class="hero-wrapper">
    <div
      class="container slp-overflow-x-hidden"
      :class="{ gradient: data.gradient }"
    >
      <SlpRow class="container__row">
        <SlpColumn :cols="7" class="text-column">
          <div
            v-if="data.note"
            :class="{
              'hero-wrapper__animate-wrapper': data.note_animation_duration,
            }"
          >
            <div
              :class="{
                'hero-wrapper__animate-wrapper__content':
                  data?.note_animation_duration,
              }"
              :style="{ animationDuration: data?.note_animation_duration }"
            >
              <Badge v-if="data.badge" :badge="data.badge" />

              <SlpTypography
                v-for="line in data.note"
                :key="line"
                tag="h1"
                variant="heading5"
                class="note"
              >
                {{ line }}</SlpTypography
              >
            </div>
          </div>
          <div
            :class="{
              'hero-wrapper__animate-wrapper hero-wrapper__animate-wrapper--gradient':
                data?.title_animation_duration,
            }"
          >
            <div
              class="text"
              :class="[
                { gradient: data.gradient, display: data.display_size },
                {
                  'hero-wrapper__animate-wrapper__content':
                    data?.title_animation_duration,
                },
              ]"
              :style="{ animationDuration: data?.title_animation_duration }"
            >
              <SlpTypography
                v-if="data.german_title"
                :tag="data.note ? 'h2' : 'h1'"
                :variant="'heading2-bold'"
                class="slp-mt-16 slp-mt-md-0 slp-mb-16 header-text"
                >{{ data.title }}</SlpTypography
              >
              <SlpTypography
                v-else
                :tag="data.note ? 'h2' : 'h1'"
                :variant="titleVariant"
                class="slp-mt-16 slp-mt-md-0 slp-mb-16 header-text"
                >{{ data.title }}</SlpTypography
              >
              <span
                v-if="data.subtitle"
                class="text__span"
                v-html="$md.render(data.subtitle)"
              />
              <SlpTypography
                v-if="data.body_note"
                variant="body2"
                tag="p"
                class="slp-mt-16"
                >{{ data.body_note }}</SlpTypography
              >
            </div>
          </div>
          <div class="buttons slp-mt-32">
            <div
              v-if="data.primary_btn"
              :class="{
                'hero-wrapper__animate-wrapper':
                  data?.primary_btn?.button_animation_duration,
              }"
            >
              <SlpButton
                variant="primary"
                class="slp-mb-8 button"
                :class="[
                  { gradient: data.gradient },
                  {
                    'hero-wrapper__animate-wrapper__content':
                      data?.primary_btn?.button_animation_duration,
                  },
                ]"
                :style="{
                  animationDuration:
                    data?.primary_btn?.button_animation_duration,
                }"
                :data-ga-name="
                  data.primary_btn.data_ga_name || 'start your free trial'
                "
                :data-ga-location="
                  data.primary_btn.data_ga_location || 'header'
                "
                :href="data.primary_btn.url || '/free-trial/'"
                >{{ data.primary_btn.text }}
                <SlpIcon
                  v-if="data.primary_btn.icon"
                  :name="data.primary_btn.icon.name"
                  :variant="data.primary_btn.icon.variant"
                  class="slp-ml-8"
                />
              </SlpButton>
            </div>
            <div
              v-if="data.primary_btn"
              :class="{
                'hero-wrapper__animate-wrapper':
                  data?.secondary_btn?.button_animation_duration,
              }"
            ></div>
            <SlpButton
              v-if="data.secondary_btn"
              :variant="data.secondary_btn.variant || 'secondary'"
              class="slp-mb-8 hero-wrapper__button"
              :class="{
                'hero-wrapper__animate-wrapper__content':
                  data?.secondary_btn?.button_animation_duration,
              }"
              :href="
                !data.secondary_btn.modal
                  ? data.secondary_btn.url || '/sales/'
                  : undefined
              "
              :data-ga-name="data.secondary_btn.data_ga_name || 'contact sales'"
              :data-ga-location="
                data.secondary_btn.data_ga_location || 'header'
              "
              :style="{
                animationDuration:
                  data?.secondary_btn?.button_animation_duration,
              }"
              @click.native="data.secondary_btn.modal && openModal()"
              >{{ data.secondary_btn.text || 'Contact Sales' }}
              <SlpIcon
                v-if="data.secondary_btn.icon"
                :name="data.secondary_btn.icon.name"
                :variant="data.secondary_btn.icon.variant"
                class="slp-ml-8"
            /></SlpButton>
          </div>
          <div class="footnote slp-mt-32">
            <SlpTypography v-if="data.footnote" variant="body3" tag="p">{{
              data.footnote
            }}</SlpTypography>
          </div>
        </SlpColumn>
        <SlpColumn v-if="data.video" :cols="5" class="image-column column">
          <iframe
            class="slp-my-64 slp-mr-64 video"
            :src="data.video.video_url"
            width="560"
            height="315"
            :title="data.header + ' YouTube Video'"
            allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
            allowfullscreen
          ></iframe>
        </SlpColumn>
        <SlpColumn v-else-if="data.image" :cols="5" class="image-column column">
          <div
            class="image-container"
            :class="{
              'image-container--bordered': data.bordered || data.image.bordered,
              'image-container--rectangular': data.image.rectangular,
              'image-container--alt': data.image.no_image_alt,
              'image-container--rounded': data.image.rounded,
              'image-container--no-image-mobile':
                data.hide_in_mobile || data.image.hide_in_mobile,
              'image-container--plain':
                data.image.image_purple_background == false,
            }"
          >
            <div
              v-if="data.image.is_video_thumbnail"
              class="video-container"
              @click="openModal()"
            >
              <SlpIcon
                v-show="data.image.is_video_thumbnail"
                class="play-icon"
                name="play-circle"
                variant="marketing"
                size="lg"
                slp-color="color-text-link-100"
              />
              <img
                id="video-container__image"
                class="image thumbnail-image"
                :class="{
                  'image--bordered': data.image.bordered || data.bordered,
                }"
                :src="data.image.image_url"
                :alt="data.image.alt"
              />
            </div>
            <img
              v-else
              id="image-container__image"
              class="image"
              :class="{
                'image--bordered': data.image.bordered || data.bordered,
                'image--rectangular': data.image.rectangular,
                'image--rounded': data.image.rounded,
                'image--alt': data.image.no_image_alt,
                'image--position-left': data.image.position == 'left',
                'image--dim': data.image.dim,
                'image--small': data.image.small,
              }"
              :src="data.image.image_url"
              :alt="data.image.alt"
              loading="lazy"
            />
          </div>
        </SlpColumn>
        <div
          v-if="
            data.video_purple_background !== false ||
            data.video?.video_purple_background !== false ||
            data.image?.image_purple_background !== false
          "
          class="container__purple-background"
          :class="{
            'container__purple-background--no-image-mobile':
              data.hide_in_mobile ||
              data.video?.hide_in_mobile ||
              data.image?.hide_in_mobile,
          }"
        />
      </SlpRow>
    </div>
    <SolutionsVideoModal
      v-show="showModal"
      light-background
      :visible="showModal"
      @close="showModal = false"
    >
      <template #body>
        <iframe
          :src="data.modal_src"
          title="Video player"
          allow="accelerometer; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
      </template>
    </SolutionsVideoModal>
  </section>
</template>

<style lang="scss" scoped>
@import 'assets/css/animations';

@media (min-width: $breakpoint-lg) {
  .buttons {
    display: flex;
    .button:first-child {
      margin-right: $spacing-8;
    }
  }
}

/* Variables */
.hero-wrapper {
  --margin: 48px;
}
@media (min-width: $breakpoint-lg) {
  .hero-wrapper {
    --margin: 96px;
  }
}

.hero-wrapper {
  overflow: hidden;
  padding: var(--margin) 0;
  margin-bottom: var(--margin);

  @media (max-width: $breakpoint-md) {
    margin-bottom: $spacing-16;
    padding-bottom: 0;
  }
  .slp-container & {
    overflow: visible;
  }
  &__animate-wrapper {
    overflow-y: hidden;
    overflow-y: clip;
    &--gradient {
      @media (min-width: $breakpoint-lg) {
        width: 70rem;
      }
    }

    &__content {
      animation-name: intro-reveal;
      animation-fill-mode: forwards;
      animation-delay: 0.5s;
      transform: translate3d(0, 150%, 0);
    }
  }

  &__button {
    @media (max-width: $breakpoint-md) {
      width: 100%;
      justify-content: center;
      background-color: $color-surface-50;
    }
  }

  @keyframes intro-reveal {
    from {
      transform: translate3d(0, 150%, 0);
    }
    to {
      transform: translate3d(0, 0%, 0);
    }
  }
  .note {
    font-weight: 600;
    margin-bottom: $spacing-16;
  }

  .video {
    width: 100%;

    @media (max-width: $breakpoint-md) {
      margin-bottom: 0;
      margin-top: $spacing-16;
    }
  }
}

.gradient {
  .note {
    color: $color-primary-300;
    font-weight: normal;
    margin-bottom: 0;
  }
  .button {
    border: 1px solid transparent;
    border-radius: 4px;
    background: linear-gradient(90deg, black 0%, black 100%) padding-box,
      linear-gradient(90deg, #ffeff1 0%, #cbb2ff 100%) border-box;
    transition: all 0.3s;
    &:hover {
      color: black;
      background: linear-gradient(90deg, white 0%, white 100%) padding-box,
        linear-gradient(90deg, #ffeff1 0%, #cbb2ff 100%) border-box;
    }
  }
  .text {
    background: linear-gradient(267.59deg, #cbb3ff 16.24%, #ffeff1 94.71%);
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
    background-clip: text;
    text-fill-color: transparent;
  }

  @media (min-width: $breakpoint-lg) {
    .text {
      width: 70rem;
    }
  }

  @media (max-width: $breakpoint-lg) {
    .container__row {
      flex-wrap: nowrap;
    }
    .image {
      opacity: 0.75;
      position: absolute;
      top: 15%;
      height: 85%;
    }
    .note {
      font-size: 16px;
    }
    .text h2,
    .text h1 {
      font-size: 60px;
      line-height: 60px;
    }
    .buttons {
      a.button {
        width: auto;
      }
    }
  }
}

.container {
  overflow: visible;
  margin-left: auto;
  margin-right: auto;
  max-width: 1170px;
  word-wrap: break-word;

  @media (max-width: $breakpoint-xl) {
    padding: 0 $spacing-16 $spacing-8 $spacing-16;
  }

  &__row {
    display: flex;
    align-items: center;
    justify-content: space-between;
    overflow: visible;
    position: relative;

    .text {
      @media (min-width: $breakpoint-lg) {
        &.display .header-text {
          font-size: 120px;
          line-height: 120px;
        }
      }

      &__span {
        font-size: 22px;
        font-weight: 400;
        letter-spacing: -0.8px;
        line-height: 28px;

        @media (min-width: $breakpoint-sm) {
          font-size: 24px;
          line-height: 32px;
        }
      }
    }

    .buttons {
      @media (max-width: $breakpoint-md) {
        a {
          width: 100%;
          justify-content: center;
        }
      }
    }
  }

  .column {
    overflow: visible;
  }

  .text-column {
    z-index: 2;
    transition: transform 0.1s ease;
    margin-bottom: $spacing-24;
    @media (min-width: $breakpoint-lg) {
      padding-right: $spacing-32;
    }
  }

  .image-column {
    z-index: 1;
    transition: transform 0.1s ease;
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }

  .image-container {
    display: flex;
    justify-content: right;
    aspect-ratio: 14/9;

    @media (max-width: $breakpoint-md) {
      background: transparent;
      padding: 0;
      display: flex;
      justify-content: center;
      transform: none;
      opacity: 1;
    }

    &--bordered {
      margin-bottom: $spacing-64;
      overflow: hidden;
      border-bottom-right-radius: 160px;
      @media (min-width: $breakpoint-md) {
        margin: $spacing-64 0 $spacing-64 $spacing-16;
      }
      @media (max-width: $breakpoint-md) {
        margin-top: 0;
      }
    }

    &--rounded {
      clip-path: circle(0 at 50% 50%);
      animation: circular-mask 1s ease-in-out 0.2s forwards;
      @media (min-width: $breakpoint-md) {
        margin: $spacing-64 0;
      }
    }

    &--rounded,
    &--bordered {
      width: 90vw;
      max-width: 90vw;
      max-height: 90vw;
      transform: translateX(0) translateY(0) !important;
      @media (min-width: $breakpoint-sm) {
        width: 100%;
        max-width: 70vw;
        max-height: 70vw;
      }
      @media (min-width: $breakpoint-md) {
        width: 45vw;
        max-width: 480px;
        max-height: 480px;
      }
      @media (min-width: $breakpoint-lg) {
        margin: 0 0 0 $spacing-64;
      }
    }

    &--rectangular {
      width: unset;
      height: unset;
    }

    &--alt {
      margin: $spacing-32 0;
      @media (min-width: $breakpoint-md) {
        padding: $spacing-48 0;
      }
    }

    &--plain {
      margin-top: $spacing-64;
    }

    &--no-image-mobile {
      @media (max-width: $breakpoint-lg) {
        display: none;
      }
      justify-content: left !important;
      align-items: center;
      margin: $spacing-16 0 $spacing-48 0;
      /*@media (min-width: $breakpoint-md) {
        //padding-top: $spacing-64;
        //margin: 0 0 $spacing-24 0;
      }*/
      #image--container__image,
      #video--container__image {
        width: 130vw;
        transform: none;
        @media (min-width: $breakpoint-md) {
          width: 69vw;
          min-width: 69vw;
        }
        @media (min-width: $breakpoint-lg) {
          width: 69vw;
          min-width: 69vw;
        }
      }
    }

    .video-container {
      cursor: pointer;
      position: relative;

      .play-icon {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        font-size: 48px;
        color: black;
        cursor: pointer;
        z-index: 2;
      }
    }
  }

  .image {
    border-radius: 4px;
    object-fit: contain;

    &--dim {
      opacity: 0.15;
    }
    &--small {
      max-height: 530px;
    }
    &--bordered,
    &--rounded {
      height: 100%;
      transform: translate(0, 0);
    }
    &--position-left {
      object-position: left;
    }
    &--bordered {
      width: 100%;
      object-fit: cover;
    }

    &--rounded {
      width: 100%;
      object-fit: cover;
      object-position: -16px 0;
    }

    &--rectangular {
      border-bottom-right-radius: 0;
    }

    &__wrapper {
      width: 100%;
      height: 100%;
      overflow: hidden;
    }

    &--alt {
      width: 100%;
      max-width: 70vw;
      @media (min-width: $breakpoint-sm) {
        width: 100%;
      }
      @media (min-width: $breakpoint-md) {
        width: 50vw;
      }
    }
  }
  &__purple-background {
    position: absolute;
    z-index: -1;
    top: calc(0px - var(--margin));
    right: calc(300px - 40vw);
    background-color: $color-surface-800;
    height: calc(100% + var(--margin) * 2);
    width: 42vw;

    @media (max-width: $breakpoint-md) {
      transform: none;
      opacity: 1;
      bottom: 0;
      top: unset;
      left: -16px;
      height: 30%;
      width: 100vw;
    }
    &--no-image-mobile {
      @media (max-width: $breakpoint-lg) {
        display: none;
      }
    }
  }
  .aos-init,
  .aos-animate {
    @media (max-width: $breakpoint-md) {
      transform: none;
      opacity: 1;
    }
  }
}
</style>
